export declare enum TenantTransport {
    HTTP = "http"
}
export type TenantContext = {
    headers?: {
        [key: string]: string;
    };
    query?: {
        [key: string]: string;
    };
    url?: string;
};
export interface TenancyScope {
    tenant: string;
    enabled: boolean;
}
export interface TenancyEntityOptions {
    tenantField: string;
    idField: string;
}
export interface TenantEntityDto {
    tenant: string;
    tenantId: string;
}
export interface TenantEntity {
    switchTenancy(state: boolean): void;
    getTenant(): string;
    getTenantId(): string;
}
export declare function isTenantEntity(x: unknown): x is TenantEntity;
export type TenantGuard = (context: TenantContext, tenant: string) => boolean;
