"use strict";
var MtenantModule_1;
Object.defineProperty(exports, "__esModule", { value: true });
exports.MtenantModule = void 0;
const tslib_1 = require("tslib");
const common_1 = require("@nestjs/common");
const async_context_1 = require("@nestjs-steroids/async-context");
const mtenant_service_1 = require("./mtenant.service");
const constants_1 = require("./constants");
const tenancy_middleware_1 = require("./middlewares/tenancy.middleware");
let MtenantModule = MtenantModule_1 = class MtenantModule {
    configure(consumer) {
        consumer.apply(tenancy_middleware_1.TenancyMiddleware).forRoutes({
            path: '(.*)',
            method: common_1.RequestMethod.ALL,
        });
    }
    static forRoot(options) {
        const OptionsProvider = {
            provide: constants_1.MT_OPTIONS,
            useValue: options,
        };
        return {
            module: MtenantModule_1,
            providers: [OptionsProvider, mtenant_service_1.MtenantService],
            exports: [mtenant_service_1.MtenantService],
        };
    }
    static forRootAsync(options) {
        const providers = this.createAsyncProviders(options);
        return {
            module: MtenantModule_1,
            providers: [...providers, mtenant_service_1.MtenantService],
            imports: options.imports,
            exports: [mtenant_service_1.MtenantService],
        };
    }
    static createAsyncProviders(options) {
        const providers = [this.createAsyncOptionsProvider(options)];
        if (options.useClass) {
            providers.push({
                provide: options.useClass,
                useClass: options.useClass,
            });
        }
        return providers;
    }
    static createAsyncOptionsProvider(options) {
        if (options.useFactory) {
            return {
                name: constants_1.MT_OPTIONS,
                provide: constants_1.MT_OPTIONS,
                useFactory: options.useFactory,
                inject: options.inject || [],
            };
        }
        return {
            name: constants_1.MT_OPTIONS,
            provide: constants_1.MT_OPTIONS,
            useFactory: (optionsFactory) => tslib_1.__awaiter(this, void 0, void 0, function* () {
                return optionsFactory.createOptions();
            }),
            inject: [options.useExisting || options.useClass],
        };
    }
};
MtenantModule = MtenantModule_1 = tslib_1.__decorate([
    (0, common_1.Global)(),
    (0, common_1.Module)({
        imports: [async_context_1.AsyncContextModule.forRoot()],
    })
], MtenantModule);
exports.MtenantModule = MtenantModule;
