import { AsyncContext } from '@nestjs-steroids/async-context';
import { Options } from './interfaces/module.options';
import { TenantContext, TenancyScope } from './interfaces/core.interface';
import { Transport } from './transports/transport.interface';
import { Storage } from './interfaces/storage.interface';
export declare class MtenantService {
    protected options: Options;
    private readonly asyncContext;
    protected transport: Transport;
    storage: Storage<unknown>;
    constructor(options: Options, asyncContext: AsyncContext<string, any>);
    runWithinTenancyScope(context: TenantContext, handler: Function): Promise<void>;
    setTenant(tenant: string, context?: TenantContext): Promise<MtenantService>;
    getTenant(context: TenantContext): Promise<string>;
    isTenantAllowed(context: TenantContext, tenant: string): Promise<Boolean>;
    disableTenancyForCurrentScope(): MtenantService;
    protected setup(options: Options): void;
    get tenancyScope(): TenancyScope;
    get defaultTenancyScope(): TenancyScope;
    get tenancyOptions(): Options;
}
