import { Cache } from './cache/cache.interface';
import { TenantEntity, Storage } from '../interfaces/storage.interface';
export interface CachedStorageOptions {
    expire?: number;
    prefix?: string;
}
export declare class CachedStorage<T> implements Storage<T> {
    readonly storage: Storage<T>;
    readonly cache: Cache;
    options?: CachedStorageOptions;
    readonly readonly: boolean;
    readonly DEFAULT_OPTIONS: CachedStorageOptions;
    constructor(storage: Storage<T>, cache: Cache, options?: CachedStorageOptions);
    add(tenant: string, settings?: T): Promise<TenantEntity<T>>;
    remove(tenant: string): Promise<number>;
    exists(tenant: string): Promise<Boolean>;
    updateSettings(tenant: string, settings: T): Promise<TenantEntity<T>>;
    get(tenant?: string): Promise<TenantEntity<T> | Array<TenantEntity<T>>>;
    private purgeCache;
    private encode;
    private decode;
    private key;
}
