import { TenantEntity, Storage } from '../interfaces/storage.interface';
export declare class SequelizeStorage<T> implements Storage<T> {
    private readonly storageRepository;
    constructor(storageRepository: any);
    add(tenant: string, settings?: T): Promise<TenantEntity<T>>;
    remove(tenant: string): Promise<number>;
    exists(tenant: string): Promise<Boolean>;
    updateSettings(tenant: string, settings: T): Promise<TenantEntity<T>>;
    get(tenant?: string): Promise<TenantEntity<T> | Array<TenantEntity<T>>>;
    private encode;
    private decode;
}
