"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.HttpTransport = void 0;
const url_1 = require("url");
class HttpTransport {
    constructor(headerName, queryParameterName) {
        this.headerName = headerName;
        this.queryParameterName = queryParameterName;
    }
    extract(context) {
        const normalizeHeaderName = this.normalizeHeaderName(this.headerName);
        for (const header of Object.keys(context.headers || {})) {
            if (this.normalizeHeaderName(header) === normalizeHeaderName) {
                return context.headers[header];
            }
        }
        if (!context.query && context.url) {
            context.query = {
                [this.queryParameterName]: this.urlParameter(context.url, this.queryParameterName),
            };
        }
        for (const param of Object.keys(context.query || {})) {
            if (param === this.queryParameterName) {
                return context.query[param];
            }
        }
        return null;
    }
    urlParameter(url, name) {
        return new url_1.URL(url, 'https://example.org/').searchParams.get(name);
    }
    normalizeHeaderName(header) {
        return header.toLowerCase();
    }
}
exports.HttpTransport = HttpTransport;
